#property version   "2.00"

#include  <Trade\Trade.mqh>
CTrade Trade;

enum SYMBOL_TYPE{
EURUSD,
AUDCAD,
AUDCHF,
EURCHF,
EURNZD,
GBPUSD,
CADCHF,
GBPCAD,
};

struct arrayasseries
{
   double ar[];
};

#define NUMBER_OF_SYMBOLS 2

// Trading Size
input double            Lot            =0.1;

//Symbol 1
sinput string           Setting_1      = "";
input bool              Use_Symbol_01  =true;
input SYMBOL_TYPE       Symbol_01      =EURUSD;
input ENUM_TIMEFRAMES   mPeriod_01     =PERIOD_H1;
input int               TakeProfit_01  =70;
input int               StopLoss_01    =80;
input int               rsi_period_01  =11;

//Symbol 2
sinput string           Setting_2      = "";
input bool              Use_Symbol_02  =true;
input SYMBOL_TYPE       Symbol_02      =GBPUSD;
input ENUM_TIMEFRAMES   mPeriod_02     =PERIOD_H1;
input int               TakeProfit_02  =68;
input int               StopLoss_02    =67;
input int               rsi_period_02  =16;

// Arrays for storing external parameters
string   Symbols[NUMBER_OF_SYMBOLS];           // Symbol
bool     Use_Symbol[NUMBER_OF_SYMBOLS];        // Trade or Not
ENUM_TIMEFRAMES mPeriod[NUMBER_OF_SYMBOLS];    // Period
double   TakeProfit[NUMBER_OF_SYMBOLS];        // Take Profit
double   StopLoss[NUMBER_OF_SYMBOLS];          // Stop Loss
int      rsi_period[NUMBER_OF_SYMBOLS];        // Indicator period

// RSI indikator
int rsi_handle[NUMBER_OF_SYMBOLS];
/*double rsi_01[];
double rsi_02[];*/

arrayasseries rsi[NUMBER_OF_SYMBOLS];

// Entry Conditions
bool BuyCondition[NUMBER_OF_SYMBOLS],SellCondition[NUMBER_OF_SYMBOLS];

double point;


int OnInit()
  {
   InitializeInputParameters();
      
   if(_Digits==5 || _Digits==3)
      {point = _Point*10;}
   else if (_Digits==4 || _Digits==2)
      {point = _Point;}

   for(int s=0; s<NUMBER_OF_SYMBOLS; s++)
     {
      if(Use_Symbol[s]!=false)
        {
         rsi_handle[s] = iRSI(Symbols[s],mPeriod[s],rsi_period[s],PRICE_CLOSE);
        }
     }
     
   return(INIT_SUCCEEDED);
  }

void OnDeinit(const int reason)
  {

   
  }

void OnTick()
  {
   for(int s=0; s<NUMBER_OF_SYMBOLS; s++)
     {
     
      if(Use_Symbol[s]!=false)
        {
         ArraySetAsSeries(rsi[s].ar,true);
         CopyBuffer(rsi_handle[s],0,0,3,rsi[s].ar);
         
         BuyCondition[s]  =(rsi[s].ar[s]<30);
         SellCondition[s] =(rsi[s].ar[s]>70);
        }
     }

MqlTick price[NUMBER_OF_SYMBOLS];
SymbolInfoTick(Symbols[0],price[0]);
SymbolInfoTick(Symbols[1],price[1]);



   
   //open Buy
   for(int s=0; s<NUMBER_OF_SYMBOLS; s++)
     {
      if(BuyCondition[s])
         if(!PositionSelect(Symbols[s]))
           {
            Trade.PositionOpen(Symbols[s],ORDER_TYPE_BUY,Lot,price[s].ask,NormalizeDouble(price[s].ask- StopLoss[s]*point,_Digits),NormalizeDouble(price[s].ask+ TakeProfit[s]*point,_Digits));
           }
     }
   
   //open Sell
   for(int s=0; s<NUMBER_OF_SYMBOLS; s++)
     {
      if(SellCondition[s])
         if(!PositionSelect(Symbols[s]))
           {
            Trade.PositionOpen(Symbols[s],ORDER_TYPE_SELL,Lot,price[s].bid,NormalizeDouble(price[s].bid+ StopLoss[s]*point,_Digits),NormalizeDouble(price[s].bid- TakeProfit[s]*point,_Digits));
           }
     }
   
   
   
  }

void InitializeInputParameters()
  {

Use_Symbol[0] = Use_Symbol_01;
Symbols[0] = EnumToString(Symbol_01);
mPeriod[0]= mPeriod_01;
TakeProfit[0]=TakeProfit_01;
StopLoss[0]=StopLoss_01;
rsi_period[0]=rsi_period_01;


Use_Symbol[1] = Use_Symbol_02;
Symbols[1] = EnumToString(Symbol_02);
mPeriod[1]= mPeriod_02;
TakeProfit[1]=TakeProfit_02;
StopLoss[1]=StopLoss_02;
rsi_period[1]=rsi_period_02;
  }